/*
   Gspoof v. 2.0 - callbacks.c
                                    */
#include <gtk/gtk.h>

#include "callbacks.h"
#include "interface.h"

/* boolean value */
u_short multipkg_boolean;
u_short datacontrol_boolean;
u_short linkl;

/* random value */
u_long seq;
u_long ack;
u_short id;
u_short urgp;

char *device; /* device (eth0, eth1, ppp0) */
u_char *ebuf; /* error buffer */
struct libnet_link_int *network; /* "network descriptor" */

u_long shost, dhost;   /* IP */
struct ether_addr *ethaddr; /* eth address */

/* flags opt */
u_short furg, fack, fpsh, frst, fsyn, ffin;

void on_RESETBUT_clicked (GtkButton *button, gpointer user_data)
{
   to_DEFAULT();
   info ("\nRestoring default value done\n");
}

void on_QUIT_BUTTON_clicked (GtkButton *button, gpointer user_data)
{
   gtk_main_quit();
}

void delete_event(GtkWidget *widget, gpointer data)
{
   gtk_main_quit();
}

void on_MULTIPKG_toggled (GtkToggleButton *togglebutton, gpointer user_data)
{
   if (!multipkg_boolean)
     {
	multipkg_boolean=1;
	gtk_entry_set_editable (GTK_ENTRY (DELAY), TRUE);
	gtk_entry_set_editable (GTK_ENTRY (DURATE), TRUE);
     }
   else
     {
	multipkg_boolean=0;
	gtk_entry_set_editable (GTK_ENTRY (DELAY), FALSE);
	gtk_entry_set_editable (GTK_ENTRY (DURATE), FALSE);
     }
}

void on_DATACONTROL_toggled (GtkToggleButton *togglebutton, gpointer user_data)
{
   if (!datacontrol_boolean)
     {
	datacontrol_boolean=1;
	gtk_entry_set_editable (GTK_ENTRY (DATA), TRUE);
     }
   else
     {
	datacontrol_boolean=0;
	gtk_entry_set_editable (GTK_ENTRY (DATA), FALSE);
     }
}

void on_SENDBUT_clicked (GtkButton *button, gpointer user_data)
{
   u_char *packet;
   u_short sport, dport;
   u_short flag;
   u_short w; /* byte written */
   u_short len; /* packet lenght */
   u_short datalen; /* data (tcp payload) lenght */
   u_char *data; /* data (tcp payload) */
   int sd; /* socket descriptor */

   /* delay opt */
   u_short delay;
   u_short durate;
   u_long dcount;
     
   /* temp variable 4 eth addr */
   u_char *seth_temp;
   u_char *deth_temp;

   /* eth addr */
   u_char *seth;
   u_char *deth;

   /* eth type */
   u_char *ethtype;
   u_short evalue;
   
   /* other opt */
   u_short tos;
   u_short ttl;
   u_short win;
   
   /* END of variable declaration */
   
   flag = 0x00;
   datalen = 0;
   data = NULL;
   
   tos = atoi (gtk_entry_get_text (GTK_ENTRY(ip_tos_txt)));
   ttl = atoi (gtk_entry_get_text (GTK_ENTRY(ip_ttl_txt)));
   win = atoi (gtk_entry_get_text (GTK_ENTRY(tcp_win_txt)));
     
   seq = atol (gtk_entry_get_text (GTK_ENTRY(tcp_seq_txt)));
   ack = atol (gtk_entry_get_text (GTK_ENTRY(tcp_ack_txt)));
   id = atoi (gtk_entry_get_text (GTK_ENTRY(ip_id_txt)));
   urgp = atoi (gtk_entry_get_text (GTK_ENTRY(tcp_urg_txt)));

   if (tos > 255 || atoi (gtk_entry_get_text (GTK_ENTRY(ip_tos_txt))) < 0)
     {
	info ("TOS is not valid! must be between 0 and 255\n");
	return;
     }

   if (ttl > 255 || atoi (gtk_entry_get_text (GTK_ENTRY(ip_ttl_txt))) < 0)
     {
	info ("TTL is not valid! must be between 0 and 255\n");
	return;
     }

   if (atol (gtk_entry_get_text (GTK_ENTRY(tcp_win_txt))) > 65535 || atoi (gtk_entry_get_text (GTK_ENTRY(tcp_win_txt))) < 0)
     {
	info ("Window value is not valid! it must be between 0 and 65535\n");
	return;
     }

   if (atol (gtk_entry_get_text (GTK_ENTRY(tcp_urg_txt))) > 65535 || atoi (gtk_entry_get_text (GTK_ENTRY(tcp_urg_txt))) < 0)
     {
	info ("Urgent pointer is not valid! it must be between 0 and 65535\n");
	return;
     }

   if (atol (gtk_entry_get_text (GTK_ENTRY(ip_id_txt))) > 65535 || atoi (gtk_entry_get_text (GTK_ENTRY(ip_id_txt))) < 0)
     {
	info ("ID is not valid! it must be between 0 and 65535\n");
	return;
     }

   if (atoll (gtk_entry_get_text (GTK_ENTRY(tcp_seq_txt))) > 4294970000 || atoi (gtk_entry_get_text (GTK_ENTRY(tcp_seq_txt))) < 0)
     {
	info ("Sequence number is not valid! it must be between 0 and 2^32-1\n");
	return;
     }

   if (atoll (gtk_entry_get_text (GTK_ENTRY(tcp_ack_txt))) > 4294970000 || atoi (gtk_entry_get_text (GTK_ENTRY(tcp_ack_txt))) < 0)
     {
	info ("Acknowledgement number is not valid! it must be between 0 and 2^32-1\n");
	return;
     }

   /* delay options */
   delay = atoi(gtk_entry_get_text(GTK_ENTRY(DELAY)));
   durate = atoi(gtk_entry_get_text(GTK_ENTRY(DURATE)));
   dcount = 0;

   /* eth type */
   ethtype = gtk_entry_get_text (GTK_ENTRY (combo_entry1));
   evalue = 0x0800;  /* IP value = default */
   if (strcmp(ethtype, "IP")) evalue = 0x9000; /*strcmp return 0 if strings are equal! */

   /* read ports numbers */
   sport = atoi(gtk_entry_get_text(GTK_ENTRY(tcp_src_txt)));
   if (sport < 1 || atol(gtk_entry_get_text(GTK_ENTRY(tcp_src_txt)))>65535)
     {
	info ("You must specify a source port or source port is not valid\n");
	return;
     }
   dport = atoi(gtk_entry_get_text (GTK_ENTRY(tcp_dst_txt)));
   if (dport < 1 || atol(gtk_entry_get_text(GTK_ENTRY(tcp_dst_txt)))>65535)
     {
	info ("You must specify a destination port or destination port is not valid\n");
	return;
     }

   /* control flags */
   if (ffin) flag+=0x01;
   if (fsyn) flag+=0x02;
   if (frst) flag+=0x04;
   if (fpsh) flag+=0x08;
   if (fack) flag+=0x10;
   if (furg) flag+=0x20;

   /* read payload if present */
   if (datacontrol_boolean)
     {
	data = gtk_entry_get_text(GTK_ENTRY(DATA));
	datalen = strlen (data);
     }

   /* reading IP forms */
   if ((shost = libnet_name_resolve(gtk_entry_get_text (GTK_ENTRY(ip_src_txt)), LIBNET_RESOLVE))==-1)
     {
	info ("Error reading source IP\n");
	return;
     }
   if ((dhost = libnet_name_resolve(gtk_entry_get_text (GTK_ENTRY(ip_dst_txt)), LIBNET_RESOLVE))==-1)
     {
	info ("Error reading destination IP\n");
	return;
     }

   info ("\n");

   switch (linkl)
     {
      case 0:
	/* adjust variables */
	len = LIBNET_IP_H + LIBNET_TCP_H + datalen;

	/* allocate memory */
	libnet_init_packet(len, &packet);
	if (packet == NULL)
	  {
	     info ("Cannot allocate memory for the packet!\n");
	     break;
	  }

	info ("Memory allocated\n");

	/* we open socket descriptor */
	sd = libnet_open_raw_sock(IPPROTO_RAW);
	if (sd==-1)
	  {
	     info ("Error during socket creation!\n");
	     break;
	  }

	info ("Socket open\n");

	/* IP creation */
	if (libnet_build_ip(LIBNET_TCP_H + datalen, tos, id, 0, ttl, IPPROTO_TCP, shost, dhost, NULL, 0, packet)==-1)
	  {
	     info ("Error during IP packet creation!\n");
	     break;
	  }

	info ("IP header build\n");

	/* TCP creation */
	if (libnet_build_tcp(sport, dport, seq, ack, flag, win, urgp, data, datalen, packet + LIBNET_IP_H)==-1)
	  {
	     info ("Error during TCP packet creation!\n");
	     break;
	  }

	info ("TCP header build\n");

	if (libnet_do_checksum(packet, IPPROTO_TCP, LIBNET_TCP_H + datalen) == -1)
	  {
	     info ("TCP Checksum error!\n");
	     break;
	  }

	info ("Checksum done\n");

	if (multipkg_boolean)
	  {
	     sprintf (infoline, "Writing %d ms spaced packets for %d seconds:\n", delay, durate);
	     info (infoline);
	     while (dcount < durate*1000)
	       {
		  w = libnet_write_ip(sd, packet, len);
		  if (w!=len)
		    {
		       sprintf (infoline,"Error: %d bytes has been written on %d total :(\n",w,len);
		       info (infoline);
		       break;
		    }

		  /* directly call for speed-up */
		  gtk_text_insert((GtkText *) INFO_TXT, NULL, NULL, NULL, ". ", 2);
		  usleep(delay*1000); /*ms! */
		  dcount+=delay;
	       }
	     info (" DonE!\n");
	  }
	else
	  {
	     w = libnet_write_ip(sd, packet, len);
	     if (w!=len)
	       {
		  sprintf (infoline,"Error: %d bytes has been written on %d total :(\n",w,len);
		  info (infoline);
		  break;
	       }
	     else
	       {
		  sprintf (infoline,"-- Packet has been correctly send (total %d bytes) --\n",len);
		  info (infoline);
	       }
	  }

	/* at the end we close raw_socket */
	if (libnet_close_raw_sock(sd) == -1)
	  info ("Error during socket closing!\n");

	libnet_destroy_packet(&packet);
	break;

      case 1:
	len = LIBNET_ETH_H + LIBNET_IP_H + LIBNET_TCP_H + datalen;

	/* reading device */
	device = gtk_entry_get_text(GTK_ENTRY(eth_int_txt));

	/* read MAC from GTK */
	seth_temp = gtk_entry_get_text(GTK_ENTRY(eth_src_txt));
	deth_temp = gtk_entry_get_text(GTK_ENTRY(eth_dst_txt));

	seth = malloc (6*sizeof(u_char));
	deth = malloc (6*sizeof(u_char));

	seth = myconvert (seth_temp);
	if (seth==NULL)
	  {
	     info ("Source MAC address is not valid\n");
	     break;
	  }
	deth = myconvert (deth_temp);
	if (deth==NULL)
	  {
	     info ("Destination MAC address is not valid\n");
	     break;
	  }

	/* allocate memory */
	libnet_init_packet(len, &packet);
	if (packet == NULL)
	  {
	     info ("Cannot allocate memory for the packet!\n");
	     break;
	  }

	info ("Memory allocated\n");

	if ((network = libnet_open_link_interface(device, ebuf)) == NULL)
	  {
	     sprintf ("Error opening interface!%s", device);
	     info (infoline);
	     break;
	  }
	else
	  {
	     sprintf(infoline, "Interface %s correctly opened\n", device);
	     info(infoline);
	  }

	if (libnet_build_ethernet(deth, seth, evalue, NULL, 0, packet)==-1)
	  {
	     info ("Error during Ethernet header creation!\n");
	     break;
	  }

	info ("Ethernet frame build\n");

	/* IP creation */
	if (libnet_build_ip(LIBNET_TCP_H + datalen, tos, id, 0, ttl, IPPROTO_TCP, shost, dhost, NULL, 0, packet + LIBNET_ETH_H)==-1)
	  {
	     info ("Error during IP packet creation!\n");
	     break;
	  }

	info ("IP header build\n");

	/* TCP creation */
	if (libnet_build_tcp(sport, dport, seq, ack, flag, win, urgp, data, datalen, packet + LIBNET_ETH_H + LIBNET_IP_H)==-1)
	  {
	     info ("Error during TCP packet creation!\n");
	     break;
	  }

	info ("TCP header build\n");

	if (libnet_do_checksum(packet + ETH_H, IPPROTO_TCP, LIBNET_TCP_H + datalen) == -1)
	  {
	     libnet_error(LIBNET_ERR_FATAL, "Checksum TCP error!\n");
	     break;
	  }
	if (libnet_do_checksum(packet + ETH_H, IPPROTO_IP, LIBNET_IP_H) == -1)
	  {
	     libnet_error(LIBNET_ERR_FATAL, "Checksum IP error!\n");
	     break;
	  }

	info ("Checksum done\n");

	if (multipkg_boolean)
	  {
	     sprintf (infoline, "Writing %d ms spaced packets for %d seconds:\n", delay, durate);
	     info (infoline);
	     while (dcount < durate*1000)
	       {
		  w = libnet_write_link_layer(network, device, packet, len);
		  if (w!=len)
		    {
		       sprintf (infoline,"Error: %d bytes has been written on %d total :(\n",w,len);
		       info (infoline);
		       break;
		    }
		  gtk_text_insert((GtkText *) INFO_TXT, NULL, NULL, NULL, ". ", 2);
		  usleep(delay*1000); /*ms! */
		  dcount+=delay;
	       }
	     info (" DonE!\n");
	  }
	else
	  {
	     w = libnet_write_link_layer(network, device, packet, len);
	     if (w!=len)
	       {
		  sprintf (infoline,"Error: %d bytes has been written on %d total :(\n",w,len);
		  info (infoline);
		  break;
	       }
	     else
	       {
		  sprintf (infoline,"-- Packet has been correctly send (total %d bytes) --\n",len);
		  info (infoline);
	       }

	  }

	/* close all */
	if (libnet_close_link_interface(network)==-1)
	  info ("Error closing interface\n");

	libnet_destroy_packet(&packet);
	break;
     }
   
   return;
}

/* link layer button - case 1: */
void on_togglebutton1_toggled (GtkToggleButton *togglebutton, gpointer user_data)
{
   if (!linkl)
     {
	linkl=1;
	gtk_entry_set_editable (GTK_ENTRY (eth_int_txt), TRUE);
	gtk_entry_set_editable (GTK_ENTRY (eth_src_txt), TRUE);
	gtk_entry_set_editable (GTK_ENTRY (eth_dst_txt), TRUE);
     }
   else
     {
	linkl=0;
	gtk_entry_set_editable (GTK_ENTRY (eth_int_txt), FALSE);
	gtk_entry_set_editable (GTK_ENTRY (eth_src_txt), FALSE);
	gtk_entry_set_editable (GTK_ENTRY (eth_dst_txt), FALSE);
     }
}

void on_CREDIT_BUTTON_clicked (GtkButton *button, gpointer user_data)
{
   info ("\nGspoof 2.0 - Written in C and GTK under Slackware Linux, August 0x02, Embyte (embyte@madlab.it)\n");
}

void to_DEFAULT()
{
   struct sockaddr_in sin;

   /* reset some defaults value */
   furg = fack = fpsh = frst = fsyn = ffin = multipkg_boolean = linkl = datacontrol_boolean = 0;
      
   /* put default value */
   gtk_entry_set_text (GTK_ENTRY (ip_ttl_txt), "64");
   gtk_entry_set_text (GTK_ENTRY (ip_tos_txt), "8");
   gtk_entry_set_text (GTK_ENTRY (tcp_win_txt), "32767");
   gtk_entry_set_text (GTK_ENTRY (DELAY), "100");

   /* generate random value */
   libnet_seed_prand();
   id = (u_short) libnet_get_prand(LIBNET_PRu16);
   seq = libnet_get_prand(LIBNET_PRu32);
   ack = libnet_get_prand(LIBNET_PRu32);
   urgp = (u_short) libnet_get_prand(LIBNET_PRu16);

   gtk_entry_set_text((GtkEntry *)ip_id_txt, ltostr(id));
   gtk_entry_set_text((GtkEntry *)tcp_seq_txt, ltostr(seq));
   gtk_entry_set_text((GtkEntry *)tcp_ack_txt, ltostr(ack));
   gtk_entry_set_text((GtkEntry *)tcp_urg_txt, ltostr(urgp));

   /* now at beginning we probe for network */
   if (device==NULL)
     {
	if (libnet_select_device(&sin, &device, ebuf) == -1)
	  {
	     sprintf(infoline, "libnet_select_device failed: %s\n", ebuf);
	     gtk_entry_set_text (GTK_ENTRY(eth_int_txt), infoline);
	  }

	gtk_entry_set_text (GTK_ENTRY(eth_int_txt), device);
     }

   /* now we probe for device 's IP/MAC */
  
   if ((network = libnet_open_link_interface(device, ebuf)) == NULL)
     {
	libnet_error(LIBNET_ERR_FATAL, "libnet_open_link_interface: %s\n", ebuf);
     }

   shost = libnet_get_ipaddr(network, device, ebuf);
   if (shost == -1)
     {
	sprintf(infoline, "autodetect device ip failed: %s\n", ebuf);
	gtk_entry_set_text (GTK_ENTRY(eth_int_txt), infoline);
     }

   gtk_entry_set_text (GTK_ENTRY(ip_src_txt), libnet_host_lookup(ntohl(shost), LIBNET_DONT_RESOLVE));

   ethaddr = libnet_get_hwaddr(network, device, ebuf);
   if (ethaddr == NULL)
     {
	sprintf(infoline, "autodetect device MAC failed: %s\n", ebuf);
	gtk_entry_set_text (GTK_ENTRY(eth_int_txt), infoline);
     }
   /* I use infoline here to print mac addr to video */
   sprintf(infoline, "%X:%X:%X:%X:%X:%X", ethaddr->ether_addr_octet[0], ethaddr->ether_addr_octet[1], ethaddr->ether_addr_octet[2], ethaddr->ether_addr_octet[3], ethaddr->ether_addr_octet[4], ethaddr->ether_addr_octet[5]);
   gtk_entry_set_text (GTK_ENTRY(eth_src_txt), infoline);

   /* close network descriptor */
   libnet_close_link_interface(network);

}

void info (char * line)
{
   gtk_text_insert((GtkText *) INFO_TXT, NULL, NULL, NULL, line, -1);
}

/* flags */
void on_URGCHECK_toggled (GtkToggleButton *togglebutton, gpointer user_data)
{
   if (!furg) furg=1;
   else furg=0;
}

void on_ACKCHECK_toggled (GtkToggleButton *togglebutton, gpointer user_data)
{
   if (!fack) fack=1;
   else fack=0;
}

void on_PSHCHECK_toggled (GtkToggleButton *togglebutton, gpointer user_data)
{
   if (!fpsh) fpsh=1;
   else fpsh=0;
}

void on_RSTCHECK_toggled (GtkToggleButton *togglebutton, gpointer user_data)
{
   if (!frst) frst=1;
   else frst=0;
}

void on_SYNCHECK_toggled (GtkToggleButton *togglebutton, gpointer user_data)
{
   if (!fsyn) fsyn=1;
   else fsyn=0;
}

void on_FINCHECK_toggled (GtkToggleButton *togglebutton, gpointer user_data)
{
   if (!ffin) ffin=1;
   else ffin=0;
}
